#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <sys/stat.h>

int main ( int argc, char **argv ) {
   int fd, c, debug_level = 0;
   unsigned long long shift;
   char sopt[] = "s:v", size[ 40 ] = "10M", buf[] = "\0";
   while( -1 != ( c = getopt( argc, argv, sopt ) ) )
      switch( c ) {
         case 's':
            strcpy( size, optarg );
            break;
         case 'v':
            debug_level++;
            break;
         default :
            printf( "опции могут быть только: %s\n", sopt );
            exit( EXIT_FAILURE );
      }
   shift = atol( size );
   if( 0 == shift ) 
      printf( "недопустимый размер: %s\n", size ), exit( EXIT_FAILURE );
   c = size[ strlen( size ) - 1 ];
   if( 'K' == c || 'k' == c ) shift *= 1024L;
   if( 'M' == c || 'm' == c ) shift *= 1024L * 1024L;
   if( 'G' == c || 'g' == c ) shift *= 1024L * 1024L * 1024L;
   if( optind != argc - 1 ) 
      printf( "не указано имя файла\n" ), exit( EXIT_FAILURE );
   if( debug_level > 0 ) printf( "создаётся файл %s размером %lld байт\n", argv[ optind ], shift );
   if( ( fd = creat( argv[ optind ], S_IRUSR | S_IWUSR | S_IRGRP | S_IROTH ) ) < 0 )
      perror( "ошибка создания" ), exit( EXIT_FAILURE );
   if( write( fd, buf, 1 ) != 1 )
      perror( "ошибка записи" ), exit( EXIT_FAILURE );
/* то же самое:
   if( lseek64( fd, shift - 1, SEEK_SET ) == -1 )
      perror( "ошибка расширения" ), exit( EXIT_FAILURE );
   if( write( fd, buf, 1 ) != 1 )
      perror( "ошибка записи" ), exit( EXIT_FAILURE );
*/
   if( -1 == pwrite64( fd, buf, 1, shift - 1 ) ) 
      perror( "ошибка расширения" ), exit( EXIT_FAILURE );
   close( fd );
   exit( EXIT_SUCCESS );
} 


